# DO NOT EDIT this file by hand!
# It is generated from corresponding Open API schema.
# Visit `yaookctl/commands/generate/model.py` for further details.

# generated by datamodel-codegen:
#   filename:  <stdin>

from __future__ import annotations

from typing import List, Optional

from pydantic import BaseModel, Field


class CahUsers(BaseModel):
    include_users: Optional[List[str]] = None
    rollout: Optional[bool] = False


class ControlPlaneEndpoint(BaseModel):
    host: Optional[str] = None
    port: Optional[int] = None


class ControlPlaneRef(BaseModel):
    apiVersion: Optional[str] = None
    kind: Optional[str] = None
    name: Optional[str] = None


class Ipsec(BaseModel):
    eap_psk: Optional[str] = None
    enabled: Optional[bool] = None
    esp_proposals: Optional[str] = None
    local_networks: Optional[List[str]] = None
    peer_networks: Optional[List[str]] = None
    proposals: Optional[str] = None
    remote_addrs: Optional[bool] = None
    remote_private_addrs: Optional[str] = None
    test_enabled: Optional[bool] = None
    virtual_subnet_pool: Optional[str] = None


class Lcm(BaseModel):
    MANAGED_K8S_RELEASE_THE_KRAKEN: Optional[bool] = True
    MANAGED_PROVIDER_IDENTITY: Optional[bool] = True
    PASS_COMPANY_USERS: Optional[bool] = False
    SSH_COMPANY_USERS: Optional[bool] = False
    TF_VAR_keypair: Optional[str] = 'firstnamelastname-hostname-gendate'
    WG_COMPANY_USERS: Optional[bool] = False
    WG_USAGE: Optional[bool] = True
    wg_conf_name: Optional[str] = 'wg0'
    wg_user: Optional[str] = 'firstnamelastname'


class LoadBalancing(BaseModel):
    haproxy_stats_port: Optional[int] = None
    lb_ports: Optional[List[int]] = None
    openstack_lbaas: Optional[bool] = None
    vrrp_priorities: Optional[List[int]] = None


class Miscellaneous(BaseModel):
    cluster_behind_proxy: Optional[bool] = None
    custom_chrony_configuration: Optional[bool] = None
    custom_ntp_pools: Optional[List[str]] = None
    custom_ntp_servers: Optional[List[str]] = None
    http_proxy: Optional[str] = None
    https_proxy: Optional[str] = None
    no_proxy: Optional[str] = None
    openstack_network_name: Optional[str] = None
    vm_max_map_count: Optional[int] = None
    wireguard_on_workers: Optional[bool] = False


class OpenStackRC(BaseModel):
    secretRef: str


class AdditionalUser(BaseModel):
    gpg_id: Optional[str] = None
    ident: Optional[str] = None
    pub_key: Optional[str] = None


class Passwordstore(BaseModel):
    additional_users: Optional[List[AdditionalUser]] = None
    rollout_company_users: Optional[bool] = None


class Terraform(BaseModel):
    azs: Optional[List[str]] = Field(
        ['AZ1', 'AZ2', 'AZ3'],
        description="If 'enable_az_management=true' defines which availability zones of your cloud to use to distribute the spawned server for better HA. Additionally the count of the array will define how many gateway server will be spawned. The naming of the elements doesn't matter if 'enable_az_management=false'.",
    )
    create_root_disk_on_volume: Optional[bool] = None
    dualstack_support: Optional[bool] = False
    enable_az_management: Optional[bool] = None
    gateway_flavor: Optional[str] = 'XS'
    gateway_image_name: Optional[str] = 'Debian 11 (bullseye)'
    masters: Optional[int] = None
    public_network: Optional[str] = None
    root_disk_volume_type: Optional[str] = None
    subnet_cidr: Optional[str] = '172.30.154.0/24'
    subnet_v6_cidr: Optional[str] = None
    worker_flavors: Optional[List[str]] = None
    workers: Optional[int] = None


class Peer(BaseModel):
    ident: Optional[str] = None
    pub_key: Optional[str] = None
    s2s_bgp_as: Optional[str] = None
    s2s_enabled: Optional[bool] = None
    s2s_ip: Optional[str] = None
    s2s_peer_bgp_as: Optional[str] = None
    s2s_peer_ip: Optional[str] = None
    s2s_peer_pub_key: Optional[str] = None
    s2s_peer_public_endpoint: Optional[str] = None
    s2s_port: Optional[str] = None
    s2s_transfer_subnet: Optional[str] = None


class Wireguard(BaseModel):
    ip_cidr: Optional[str] = '172.30.153.64/26'
    ip_gw: Optional[str] = '172.30.153.65/26'
    ipv6_cidr: Optional[str] = None
    ipv6_gw: Optional[str] = None
    peers: Optional[List[Peer]] = None
    port: Optional[int] = 7777
    rollout_company_users: Optional[bool] = None


class Spec(BaseModel):
    cah_users: Optional[CahUsers] = Field(None, alias='cah-users')
    controlPlaneAvailabilityZones: Optional[List[str]] = None
    controlPlaneEndpoint: Optional[ControlPlaneEndpoint] = None
    controlPlaneRef: Optional[ControlPlaneRef] = None
    ipsec: Optional[Ipsec] = None
    lcm: Optional[Lcm] = None
    load_balancing: Optional[LoadBalancing] = Field(None, alias='load-balancing')
    miscellaneous: Optional[Miscellaneous] = None
    openStackRC: OpenStackRC
    passwordstore: Optional[Passwordstore] = None
    terraform: Optional[Terraform] = None
    wireguard: Optional[Wireguard] = None


class Gateway(BaseModel):
    azs: Optional[List[str]] = None
    flavor: Optional[str] = None


class Openstack(BaseModel):
    floatingIps: Optional[int] = Field(
        None, description='The number of used floating IP addresses'
    )
    instances: Optional[int] = Field(None, description='The number of instances')
    ram: Optional[int] = Field(None, description='The amount of used RAM, in MiB')
    securityGroups: Optional[int] = Field(
        None, description='The number of used security groups'
    )
    serverGroups: Optional[int] = Field(
        None, description='The number of used server groups'
    )
    vcpus: Optional[int] = Field(None, description='The number of used virtual CPUs')


class Status(BaseModel):
    bootstrapReady: Optional[bool] = None
    failureMessage: Optional[str] = None
    failureReason: Optional[str] = None
    gateway: Optional[Gateway] = None
    infrastructureReady: Optional[bool] = None
    openstack: Optional[Openstack] = None
    phase: Optional[str] = None
    ready: Optional[bool] = None
    serviceReady: Optional[bool] = None


class Metadata(BaseModel):
    name: Optional[str] = None
    namespace: Optional[str] = None


class YaookCluster(BaseModel):
    spec: Spec
    status: Optional[Status] = None
    metadata: Optional[Metadata] = None
